'use strict';

var ComposicoesController = angular.module('ComposicoesController', []);

ComposicoesController.controller('ComposicoesCtrl', ['$scope', '$location', '$routeParams', 'Construcao', 'Material', 'UploadApp', 'CacheApp',
    ($scope, $location, $routeParams, Construcao, Material, UploadApp, CacheApp) => {

        $scope.getComposicoes = () => {
        $scope.composicoes = undefined;
            Construcao.getComposicoes($scope.construcao.Id,
                (data) => {
                    $scope.composicoes = data.Instance;
                    for (var i in $scope.composicoes) {
                        $scope.composicoes[i].IdCount = i;
                        for (var j in $scope.composicoes[i].Itens) {
                            $scope.composicoes[i].Itens[j].IdCount = j;
                        }
                    }
                    if ($scope.composicoes.length == 0) $('#BoxLoadWait').modal('hide');
                    if (CacheApp.getParaCadastro()) {
                        if (!$scope.materiais) $scope.materiais = [];
                        $scope.adicionarComposicao();
                        CacheApp.delParaCadastro();
                    }
                    var nova = CacheApp.getComposicao();
                    if (nova) {
                        nova.Editar = $scope.getHtmlComposicao();
                        nova.ItemEditar = $scope.getHtmlItem();
                        $scope.composicoes.unshift(nova);
                        CacheApp.delComposicao();
                    }
                });
        }

        $scope.getListaItem = (composicao) => {
            composicao.open = !composicao.open;
            composicao.HtmlSubItem = composicao.open ? $scope.getHtmlSubItem() : null;
            composicao.HtmlSubItemMobile = composicao.open ? $scope.getHtmlSubItemMobile() : null;
        }

        $scope.getListaUnidades = () => {
            Material.getListaUnidades(
                (data) => {
                    $scope.listaUnidade = data.Instance;
                });
        }

        $scope.adicionarComposicao = () => {
            var idCount = $scope.composicoes.length;
            $scope.composicoes.unshift({
                Id: 0,
                Novo: true,
                Tipo: '4',
                Codigo: '',
                Ordem: '',
                Descricao: '',
                Unidade: '',
                Itens: [],
                IdCount: idCount,
                Editar: $scope.getHtmlComposicao(),
                ItemEditar: $scope.getHtmlItem()
            });
        }

      $scope.alterarComposicao = (composicao) => {
          for (var i in composicao.Itens) {
              var item = composicao.Itens[i];
              item.Consumo = item.Coeficiente ? item.Coeficiente : '';
              item.CustoUnitario = item.ValorUnitario ? item.ValorUnitario : '';

              item.Old = {
                  Consumo: item.Consumo,
                  CustoUnitario: item.CustoUnitario,
                  Descricao: item.Descricao,
                  Tipo: item.Tipo,
                  Origem: item.Origem
              };
          }
          composicao.Old = {
              Descricao: composicao.Descricao,
              Unidade: composicao.Unidade,
              Codigo: composicao.Codigo,
              Ordem: composicao.Ordem
          };

          composicao.Novo = !composicao.Novo;
          composicao.Editar = $scope.getHtmlComposicao();
          composicao.ItemEditar = $scope.getHtmlItem();
      }

      $scope.cancelarComposicao = (composicao) => {
          if (composicao.Id == 0) {
              var idx = $scope.composicoes.indexOf(composicao)
              $scope.composicoes.splice(idx, 1);
          }
          else {

              for (var i in composicao.Itens) {
                  var item = composicao.Itens[i];

                  if (!item.Old) {
                    composicao.Itens.splice(i,1);
                    continue;
                  }

                  item.Consumo = item.Old.Consumo;
                  item.CustoUnitario = item.Old.CustoUnitario;
                  item.Descricao = item.Old.Descricao;
                  item.Tipo = item.Old.Tipo;
                  item.Origem = item.Old.Origem;
                  delete item.Old;
              }
              composicao.Descricao = composicao.Old.Descricao;
              composicao.Unidade = composicao.Old.Unidade;
              composicao.Codigo = composicao.Old.Codigo;
              composicao.Ordem = composicao.Old.Ordem;

              composicao.Novo = !composicao.Novo;
              delete composicao.Old;
          }
      }

      $scope.adicionarItem = (composicao) => {
          var idCount = composicao.Itens.length;
          composicao.Itens.unshift({
              Id: 0,
              Tipo: '',
              Codigo: '',
              Unidade: '',
              Descricao: '',
              Ordem: '',
              CustoUnitario: '',
              Consumo: '',
              Origem: '0',
              IdCount: idCount
          });
      }

      $scope.cancelarItem = (composicao, item) => {
          var idx = composicao.Itens.indexOf(item)
          composicao.Itens.splice(idx, 1);
      }

      $scope.salvarComposicao = (composicao) => {
          if (composicao.Itens && composicao.Itens.length == 0) {
            $scope.msgBoxAtencao("Atenção!", "Não é possível cadastrar composição sem item!", () => {}) ;
            return;
          }

          var composicaoNova = {
              Id: composicao.Id,
              IdConstrucao: $scope.construcao.Id,
              Codigo: composicao.Codigo,
              Descricao: composicao.Descricao,
              Unidade: composicao.Unidade,
              Ordem: composicao.Ordem,
              Itens: []
          }

          for (var i in composicao.Itens) {
            if (composicao.Itens[i].Descricao.length == 0 ||
                composicao.Itens[i].Consumo.length == 0 ) {
                //composicao.Itens[i].CustoUnitario.length == 0) {
              $scope.msgBoxAtencao("Atenção!", "Informação incompleta do item!", ()=>{})
              return;
            }

            composicaoNova.Itens.push({
                Id: composicao.Itens[i].Id,
                Consumo: composicao.Itens[i].Consumo.toString(),
                ValorUnitario: composicao.Itens[i].CustoUnitario.toString()
            });
          }

          UploadApp.setComposicao(composicaoNova, $scope.construcao.Id,
            (result) => {
                $scope.getComposicoes();
            });
      }

      $scope.excluirComposicao = (composicao) => {
          $scope.msgBoxPergunta(composicao.Descricao, 'Confirma exclusão da composição?'
              , () => {
                  Material.delMaterial($scope.construcao.Id, composicao.Id,
                      (data) => {
                          var idx = $scope.composicoes.indexOf(composicao)
                          $scope.composicoes.splice(idx, 1);
                      });
              }
              , () => {
              });
      }

    $scope.duplicaComposicao = (composicao) => {
        Construcao.duplicaComposicao($scope.construcao.Id, composicao.Id, 0, null,
            (data) => {
                $scope.getComposicoes();
            });
    }

      $scope.getListaMaterial = (fieldName) => {
          Material.getListaMaterial($scope.construcao.Id, $scope.baseSelecionada.Origem, $('#' + fieldName).val(), $scope.baseSelecionada.UF, $scope.baseSelecionada.Periodo,
              (data) => {
                  $scope.listaMaterial = [];
                  var materiais = data.Instance;
                  for (var i in materiais)
                      $scope.listaMaterial.push(materiais[i]);

                  //$('#' + fieldName).dropdown('toggle');
                  $('#' + fieldName).parent().addClass('open');
              });
      }

      $scope.pesquisaMaterial = (e, item) => {
          $scope.closeDropMaterial('txtMaterial' + item.IdCount);
          if (e.keyCode == 27) {
              $scope.closeDropMaterial(item);
              return;
          }

          if (e.target.value.length > 2) {
              $scope.getListaMaterial('txtMaterial' + item.IdCount);
          }
          else {
              $scope.closeDropMaterial(item);
          }
      }

      $scope.selecionaMaterial = (item, obj) => {
          if (item.Id == 0) {
              $scope.adicionarInsumo();
          }
          else {
              $('#txtMaterial' + obj.IdCount).val(item.Nome);

              obj.Id = item.Id;
              obj.Tipo = item.Tipo;
              obj.Codigo = item.Codigo;
              obj.Descricao = item.Nome;
              obj.Unidade = item.UnidadeSigla;
              obj.CustoUnitario = item.Valor;

              $scope.closeDropMaterial(obj);
          }
      }

      $scope.adicionarInsumo = (composicao) => {
          CacheApp.setParaCadastro();
          composicao.Editar = null;
          composicao.ItemEditar = null;

          CacheApp.setComposicao(composicao);
          $location.path('/materiais');
      }

      $scope.closeDropMaterial = (item) => {
          $('#txtMaterial' + item.IdCount).parent().removeClass('open');
      }

      $scope.textBlur = (item) => {
          if (!$scope.listaMaterial || !item.Descricao) {
              setTimeout( () => { $scope.closeDropMaterial(item); }, 200)
              return;
          }
          if ($scope.listaMaterial.length == 1 && $scope.listaMaterial[0].Nome.toLowerCase().indexOf(item.Descricao.toLowerCase()) >= 0) {
              $scope.selecionaMaterial($scope.listaMaterial[0], item);
          }
          else {
              setTimeout(() => { $scope.closeDropMaterial(item); }, 200)
          }
      }

      $scope.getComposicaoDisponivel = () => {
          Material.getComposicaoDisponivel(
              (data) => {
                  $scope.listaComposicaoDisponivel = data.Instance;
                    if ($scope.sessao.BasePublica)
                        $scope.setBaseSessao($scope.sessao.BasePublica);
                    else
                        $scope.baseSelecionada = {Origem: 0, UF:'', Periodo: ''};
              });
      }

      $scope.setBaseSessao = (IdBase) => {
        $scope.sessao.BasePublica = IdBase;
        CacheApp.setSessao($scope.sessao);

        if (IdBase == 0)  {
            $scope.baseSelecionada = {Origem: 0, UF:'', Periodo: ''};            
        }
        else {
            $scope.baseSelecionada = {};
            for(var i in $scope.listaComposicaoDisponivel)
                if ($scope.listaComposicaoDisponivel[i].Id == IdBase) {
                    $scope.baseSelecionada = $scope.listaComposicaoDisponivel[i];
                    break;
                }
        }

      }

      $scope.getHtmlSubItem = () => {
          return '' +
            '<br ng-show="composicao.open && !composicao.Novo" />' +
            '<div class="panel panel-crudlist-mini" ng-show="composicao.open && !composicao.Novo">' +
            '<div class="panel-heading tr-fonteTitulo">' +
            '    <div class="row">' +
            '	<div class="col-lg-6 col-md-6 col-sm-6">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Tipo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Código' +
            '		</div>' +
            '		<div class="col-lg-6 col-md-6 col-sm-6 text-left">' +
            '	        Descrição' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Unidade' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '	<div class="col-lg-6 col-md-6 col-sm-6 text-right">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Preço <small>({{construcao.Moeda}})</small>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Consumo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Custo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    <span ng-show="comEncargos">Enc. Social</span>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		  <span ng-show="comBDI">BDI</span>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Total <small>({{construcao.Moeda}})</small>' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '    </div>' +
            '</div>' +
            '<ul class="list-group tr-fonteItem">' +
            '    <li class="list-group-item LinhaLista" ng-repeat="subItem in composicao.Itens">' +
            '	<div class="row">' +
            '	<div class="col-lg-6 col-md-6 col-sm-6">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '		{{subItem.TipoDescricao}}' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '		{{subItem.Codigo}}' +
            '		</div>' +
            '		<div class="col-lg-6 col-md-6 col-sm-6 text-left">' +
            '		{{subItem.Descricao}}' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '		{{subItem.Unidade}}' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '	<div class="col-lg-6 col-md-6 col-sm-6 text-right">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero format-valor="subItem.ValorUnitario" format-tipo="\'real\'"></formata-numero>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero format-valor="subItem.Coeficiente" format-tipo="\'coeficiente\'"></formata-numero>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero format-valor="subItem.Custo" format-tipo="\'real\'"></formata-numero>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero format-valor="subItem.EncargoSocial" format-tipo="\'real\'" ng-show="comEncargos"></formata-numero>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero format-valor="subItem.BDI" format-tipo="\'real\'" ng-show="comBDI"></formata-numero>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero ng-show="comEncargos && comBDI" format-valor="subItem.CustoTotal" format-tipo="\'real\'"></formata-numero>' +
            '			<formata-numero ng-show="!comEncargos && comBDI" format-valor="subItem.CustoBDI" format-tipo="\'real\'"></formata-numero>' +
            '			<formata-numero ng-show="comEncargos && !comBDI" format-valor="subItem.CustoEncargos" format-tipo="\'real\'"></formata-numero>' +
            '			<formata-numero ng-show="!comEncargos && !comBDI" format-valor="subItem.Custo" format-tipo="\'real\'"></formata-numero>' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '	</div>' +
            '    </li>' +
            '</ul>' +
            '</div>';
      }

      $scope.getHtmlSubItemMobile = () => {
          return '' +
            '<br ng-show="composicao.open && !composicao.Novo" />' +
            '<div class="panel panel-crudlist-mini" ng-show="composicao.open && !composicao.Novo">' +
            '<div class="panel-heading tr-fonteTitulo">' +
            '   <div class="row">' +
            '	<div class="col-xs-12">' +
            '           Detalhe da Composição' +
            '	</div>' +
            '   </div>' +
            '</div>' +
            '<ul class="list-group tr-fonteItem">' +
            '    <li class="list-group-item LinhaLista" ng-repeat="subItem in composicao.Itens">' +
            '	<div class="row">' +
            '	<div class="col-xs-12">' +
            '		<p>' +
            '		{{subItem.TipoDescricao}}' +
            '		</p>' +
            '		<p>' +
            '		Código: {{subItem.Codigo}}' +
            '		</p>' +
            '		<p>' +
            '		Descrição: {{subItem.Descricao}}' +
            '		</p>' +
            '		<p>' +
            '		Unidade: {{subItem.Unidade}}' +
            '		</p>' +
            '		<p>' +
            '			Preço ({{construcao.Moeda}}): <formata-numero format-valor="subItem.ValorUnitario" format-tipo="\'real\'"></formata-numero>' +
            '		</p>' +
            '		<p>' +
            '			Consumo: <formata-numero format-valor="subItem.Coeficiente" format-tipo="\'coeficiente\'"></formata-numero>' +
            '		</p>' +
            '		<p>' +
            '			Custo ({{construcao.Moeda}}): <formata-numero format-valor="subItem.Custo" format-tipo="\'real\'"></formata-numero>' +
            '		</p>' +
            '		<p ng-show="comEncargos">' +
            '			Enc. Social: <formata-numero format-valor="subItem.EncargoSocial" format-tipo="\'real\'"></formata-numero>' +
            '		</p>' +
            '		<p ng-show="comBDI">' +
            '			BDI: <formata-numero format-valor="subItem.BDI" format-tipo="\'real\'"></formata-numero>' +
            '		</p>' +
            '		<p>' +
            '			Custo Total: <formata-numero ng-show="comEncargos && comBDI" format-valor="subItem.CustoTotal" format-tipo="\'real\'"></formata-numero>' +
            '			<formata-numero ng-show="!comEncargos && comBDI" format-valor="subItem.CustoBDI" format-tipo="\'real\'"></formata-numero>' +
            '			<formata-numero ng-show="comEncargos && !comBDI" format-valor="subItem.CustoEncargos" format-tipo="\'real\'"></formata-numero>' +
            '			<formata-numero ng-show="!comEncargos && !comBDI" format-valor="subItem.Custo" format-tipo="\'real\'"></formata-numero>' +
            '		</p>' +
            '	</div>' +
            '	</div>' +
            '    </li>' +
            '</ul>' +
            '</div>';
      }

      $scope.getHtmlComposicao = function() {
          return '' + 
            '<form role="form" class="form" name="formComposicao">' +
            '    <div class="row" ng-show="deuErro">' +
            '	<div class="form-group">' +
            '	    <div class="col-lg-4 col-lg-offset-4 col-md-4 col-md-offset-4 col-sm-4 col-sm-offset-4">' +
            '		<mensagemform></mensagemform>' +
            '	    </div>' +
            '	</div>' +
            '    </div>' +
            '	<div class="form-group">' +
            '        <div class="col-lg-10 col-md-10 col-sm-10 col-xs-8">' +
            '           <label>Composição</label>'+
            '	        <input type="text" class="form-control input-lg" placeholder="Nome da Composição" maxlength="500" ng-model="composicao.Descricao" required>' +
            '        </div>' +
            '   </div>' +
            '	<div class="form-group">' +
            '       <div class="col-lg-8 col-md-8 col-sm-8 col-xs-12"><br \>' +
            '            <label>Unidade Referência</label>'+
            '	        <select class="form-control input-lg" ng-model="composicao.Unidade" ng-init="composicao.Unidade = composicao.Unidade + \'\'" required>' +
            '	            <option value="" selected disabled> Unidade </option>' +
            '	            <option ng-repeat="unidade in listaUnidade" value="{{unidade.Sigla}}">{{unidade.Descricao}} ({{unidade.Sigla}})</option>' +
            '	        </select>' +
            '       </div>' +
            '       <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12"><br \>' +
            '            <label>Código</label>'+
            '	        <input type="text" class="form-control input-lg" placeholder="Código" maxlength="20" ng-model="composicao.Codigo" ng-init="composicao.Codigo =  composicao.Codigo + \'\'">' +
            '       </div>' +
            '        <div class="col-lg-2 col-md-2 col-sm-2 col-xs-4 text-center"> ' +
            '	        <itemsalvar ng-click="!formComposicao.$invalid && salvarComposicao(composicao)"></itemsalvar>' +
            '	        <itemcancelar ng-click="cancelarComposicao(composicao)"></itemcancelar>' +
            '        </div>' +
            '   </div>' +
            '</form>';
      }

      $scope.getHtmlItem = () => {
          return '' + 
            '<div class="panel panel-crudlist-mini">' +
            '    <div class="panel-heading">' +
            '	<div class="row">' +
            '	    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
            '		<div class="btn btn-vigha-default btn-block" ng-click="adicionarItem(composicao)"><i class="glyphicon glyphicon-plus-sign"></i> ADICIONAR INSUMO</div>' +
            '	    </div>' +
            '	</div>' +
            '    </div>' +
            '    <ul class="list-group">' +
            '	<li class="list-group-item" ng-show="composicao.Itens && composicao.Itens.length == 0">' +
            '	    <h3 class="text-left">Nenhum item cadastrado. <br /><br /> <small><span class="fonteLink" ng-click="adicionarItem(composicao)">Clique aqui</span> e adicione um novo item à composição.</small> </h3>' +
            '	</li>' +
            '	<li class="list-group-item LinhaLista" ng-mouseover="mouseoversub=true" ng-mouseleave="mouseoversub=false"  ng-repeat="subItem in composicao.Itens">' +
            '	    <form role="form" class="form" name="formItem">' +
            '		    <div class="row">' +
            '		        <div class="form-group">' +
            '			        <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '                       <div ng-show="subItem.Tipo != 4">' +
            '                           <label>Base Insumos</label>'+
//            '                           <select class="form-control" ng-model="subItem.Origem" ng-init="subItem.Origem = subItem.Id != 0 ? subItem.Origem : (sessao.BasePublica ? sessao.BasePublica : \'0\')" ng-change="setBaseSessao(subItem.Origem)">'+
            '                           <select class="form-control" ng-model="subItem.Origem" ng-init="subItem.Origem = sessao.BasePublica ? sessao.BasePublica : \'0\'" ng-change="setBaseSessao(subItem.Origem)">'+
            //'				                <option value="0" selected="selected"> Base Própria </option>' +
            '                               <option ng-repeat="base in listaComposicaoDisponivel" value="{{base.Id}}">{{base.Descricao}}</option>' +
            '				            </select>' +
            '			            </div>' +
            '                       <div ng-show="subItem.Tipo == 4">' +
            '			                {{subItem.TipoDescricao}}' +
            '			            </div>' +
            '			        </div>' +
            '			        <div class="col-lg-5 col-md-5 col-sm-5 col-xs-12">' +
            '                       <div class="showMobile"><br /></div>' +
            '                       <div ng-show="subItem.Tipo != 4">' +
            '                       <label>Insumo</label>'+
            '				        <input type="text" placeholder="Digite o material, equipamento, mão-de-obra ou composição" ng-model="subItem.Descricao"' +
            '				            id="txtMaterial{{subItem.IdCount}}" class="form-control dropdown-toggle" aria-haspopup="true"' +
            '				            aria-expanded="false" ng-keyup="pesquisaMaterial($event, subItem)"' +
            '				            data-toggle="dropdown" ng-blur="textBlur(subItem)" autocomplete="off" autofocus required />' +
            '				        <ul class="dropdown-menu">' +
            '                           <li class="list-group-item LinhaListaHand" ng-repeat="material in listaMaterial" ng-click="selecionaMaterial(material, subItem)">' +
            '                               <div class="row">' +
            '                                   <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 text-left textoInsumo">' +
            '                                       {{material.Nome}}' +
            '                                   </div>' +
            '                               </div>' +
            '                               <div class="row" ng-show="material.Titulo">' +
            '                                   <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 text-left ValorInsumo">' +
            '                                       {{material.Titulo}} ' +
            '                                   </div>' +
            '                               </div>' +
            '                               <div class="row">' +
            '                                   <div class="col-lg-4 col-md-4 col-sm-4 col-xs-6 text-left ValorInsumo">' +
            '                                       <small>Cod:</small> {{material.Codigo}} ' +
            '                                   </div>' +
            '                                   <div class="col-lg-8 col-md-8 col-sm-8 col-xs-6 text-right ValorInsumo">' +
            '                                       <small>{{construcao.Moeda}}</small> <formata-numero format-valor="material.Valor" format-tipo="\'real\'"></formata-numero> / <small>{{material.UnidadeSigla}}</small>' +
            '                                   </div>' +
            '                               </div>' +
            '                           </li>' +
            '				            <li>' +
            '					            <a ng-click="adicionarInsumo(composicao)" class="itemColuna" style="cursor:pointer">CADASTRAR MATERIAL, EQUIPAMENTO, MÃO-DE-OBRA. <i class="glyphicon glyphicon-plus"></i></a>' +
            '				            </li>' +
            '				        </ul>' +
            '			            </div>' +
            '                       <div ng-show="subItem.Tipo == 4">' +
            '			                {{subItem.Descricao}}' +
            '			            </div>' +
            '			        </div>' +
            '			        <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '			            <div class="form-group">' +
            '				            <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">' +
            '                               <div class="showMobile"><br /></div>' +
            '					            <label>Consumo</label>' +
            '					            <div class="input-group">' +
            '					                <input type="text" class="form-control" placeholder="Consumo" ng-model="subItem.Consumo" ui-number-mask="7" ng-disabled="!subItem.Unidade" required>' +
            '					                <span class="input-group-addon">' +
            '						            {{subItem.Unidade}}' +
            '					                </span>' +
            '					            </div>' +
            '				            </div>' +
            '				            <div class="col-lg-4 col-md-4 col-sm-4 col-xs-12">' +
            '                               <div class="showMobile"><br /></div>' +
            '					            <label>Preço</label>' +
            '						        <div class="text-left panel-fonticon">' +
            '						            <formata-numero format-valor="subItem.CustoUnitario" format-tipo="\'real\'"></formata-numero>' +
            '					            </div>' +
            '					        </div>' +
            '				            <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '                               <div class="showMobile"><br /></div>' +
            '					            <label>Total</label>' +
            '						        <div class="text-left panel-fonticon">' +
            '					                <formata-numero format-valor="subItem.Consumo*subItem.CustoUnitario" format-tipo="\'real\'"></formata-numero>' +
            '				                </div>' +
            '				            </div>' +
            '			            </div>' +
            '			        </div>' +
            '			        <div class="col-lg-1 col-md-1 col-sm-1 col-xs-12 text-center">' +
            '			            <itemexcluir ng-show="mouseoversub" ng-click="cancelarItem(composicao, subItem)"></itemexcluir>' +
            '			        </div>' +
            '		        </div>' +
            '		    </div>' +
            '	    </form>' +
            '	</li>' +
            '    </ul>' +
            '</div>';
      }

      $scope.AcessoAndroid($routeParams, (sim) => {
          $scope.AcessoMobile = sim;

          $scope.sessao = CacheApp.getSessao();
          $scope.construcao = CacheApp.getConstrucao();
          
          $scope.getComposicaoDisponivel();
          $scope.getComposicoes();
          $scope.getListaUnidades();
      });
  }]);
